package analisi;

import java.util.HashSet;
import java.util.Set;

import org.neo4j.graphdb.Node;

import wrapper.GraphWrapper;

public class AssegnaDistanzeFlusso2 {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		new AssegnaDistanzeFlusso2();
	}
	private GraphWrapper g;
	private HashSet<String> arrivi;

	public AssegnaDistanzeFlusso2(){
		this.g=new GraphWrapper("wp_semantico");
		this.arrivi=new HashSet<String>();
		arrivi.add("Agriculture");

		arrivi.add("Culture");
		arrivi.add("Arts");
		arrivi.add("Belief");
		arrivi.add("Business");
		arrivi.add("Computing");
		arrivi.add("Education");
		arrivi.add("Geography and places");
		arrivi.add("Health");
		arrivi.add("History and events");
		arrivi.add("Language");
		arrivi.add("Law");
		arrivi.add("Mathematics");
		arrivi.add("Environment");
		arrivi.add("People");
		arrivi.add("Politics");
		arrivi.add("Society");
		arrivi.add("Philosophy");
		arrivi.add("Science");
		arrivi.add("Technology and applied sciences");
		arrivi.add("Sports");
		for(String m:arrivi){
			System.out.println("elaboro la macrocategoria "+m);
			g.getCategoria(m).setProperty("REACH"+m, 100);
			g.commit();
			this.elabora(g.getCategoria(m),m);
		}
		g.termina();
	}

	private void elabora(Node categoria, String m) {
		Set<Node> altre = g.getCategorieAppartenenza(categoria);
		double totale=0;
		int entranti=0;
		boolean prosegui=true;
		for(Node n:altre){
			System.out.println("contenuta in "+n.getProperty("name","NULL!")+" che ha FROMx:"+n.getProperty("FROM"+m,"assente")+" e REACHx:"+n.getProperty("REACH"+m,"assente"));
			entranti++;
//			se non tutti quelli che hanno FROMx ritorna, ci passerai

			if (n.hasProperty("FROM"+m) && n.hasProperty("REACH"+m))
			{
				totale+=(Double)n.getProperty("REACH"+m);

			}
			else{

				//potrebbe essere un nodo irraggiungibile e che quindi non verrà comunque mai analizzato
				if(!n.hasProperty("FROM"+m))continue;	
				//se sono qui vuol dire che esiste un nodo contenitore che ha FROMx ma non REACHx
				//quindi mi fermo nella ricorsione perché dopo ci arriverò lo stesso
				prosegui=false;
				break;
			}
		}
		if(totale==0){
			//sono nel nodo radice, ossia la macrocategoria
			//che ovviamente non ha archi entranti da categorie già valutate
			//quindi forzo il valore REACH a 1 e affermo che può proseguire
			prosegui=true;
			totale=1;
			entranti=1;
		}
		if(prosegui){
			System.out.println("Assegno a "+categoria.getProperty("name","NOME INDEFINITO")+" la proprietà REACH"+m+" a valore "+totale/(double)entranti);
			categoria.setProperty("REACH"+m, totale/(double)entranti);
			g.commit();
			//TODO itera sulle contenute e esegui elabora su esse
			for(Node c:g.getCategorieContenute(categoria)){
				elabora(c,m);
			}
		}



	}

}
