package analisi;

import java.util.HashSet;
import java.util.Set;

import org.neo4j.graphdb.Node;

import wrapper.GraphWrapper;

public class AssegnaDistanzeFlussoQuote {

	private GraphWrapper g;
	private HashSet<String> arrivi;

	public static void main(String argc[]){
	new AssegnaDistanzeFlussoQuote();	
	}
	
	/**
	 * @param args
	 */
	public AssegnaDistanzeFlussoQuote() {
		//assegna le proprietà FROMx basandosi non più  sulla distanza ma su un'euristica che 
		//premia le categorie collegate alla macrocategoria in esame con più percorsi distinti
		this.g=new GraphWrapper("wp_semantico");
		this.arrivi=new HashSet<String>();
		arrivi.add("Agriculture");

		arrivi.add("Culture");
		arrivi.add("Arts");
		arrivi.add("Belief");
		arrivi.add("Business");
		arrivi.add("Computing");
		arrivi.add("Education");
		arrivi.add("Geography and places");
		arrivi.add("Health");
		arrivi.add("History and events");
		arrivi.add("Language");
		arrivi.add("Law");
		arrivi.add("Mathematics");
		arrivi.add("Environment");
		arrivi.add("People");
		arrivi.add("Politics");
		arrivi.add("Society");
		arrivi.add("Philosophy");
		arrivi.add("Science");
		arrivi.add("Technology and applied sciences");
		arrivi.add("Sports");
		for(String m:arrivi){
			System.out.println("elaboro la macrocategoria "+m);
			this.elabora(g.getCategoria(m),100000.0,m);
		}
		g.termina();
	}

	private void elabora(Node categoria, double d,String macrocat) {
		System.out.println("aggiungo a "+categoria.getProperty("name","NESSUN-NOME")+" la distanza "+d+" da "+macrocat);
		//se la categoria ha già DISTx la sommo al valore attuale d, altrimenti la rendo uguale
		//NOTA: procedo indifferentemente nella ricorsione perché l'aggiunta dei valori è lineare,
		//quindi aggiungendo relazioni si aggiungono valori a tutti i sottorami indipendentemente 
		//da quelli precedenti
		double precedente=Double.parseDouble(categoria.getProperty("DIST"+macrocat,0).toString());
		if(precedente!=0)System.out.println(" prima era "+precedente);
		categoria.setProperty("DIST"+macrocat,d+precedente);
		g.commit();
		Set<Node> cont=g.getCategorieContenute(categoria);
		for(Node n:cont){
			elabora(n,d/(double)cont.size(),macrocat);
		}
	}
}
