package analisi;

import java.io.IOException;
import java.util.HashSet;

import org.neo4j.graphdb.DynamicRelationshipType;
import org.neo4j.graphdb.Node;
import org.neo4j.graphdb.Relationship;

import batch.Lettore;
import wrapper.GraphWrapper;

public class EliminazioneCicli {
//	questo programma elimina i cicli trovati prededentemente con l'algoritmo di Tarjan
	public static void main(String argc[]) throws IOException{
		GraphWrapper g = new GraphWrapper("wp_semantico");
		Lettore l=new Lettore("cicli.txt");
		String letta="";
		HashSet<String> componenti=new HashSet<String>();

		while((letta=l.leggi())!=null){
			if(letta.contains("-----------")){
				for(String c:componenti){
					Node cat=g.getCategoria(c);
					for(Relationship r:cat.getRelationships(DynamicRelationshipType.withName("SUBCATEGORYOF")))
						if(componenti.contains(r.getOtherNode(cat).getProperty("name","NONAME"))){
							r.delete();
							System.out.println("Elimino la relazione di "+c);
						}
					g.commit();
				}
				componenti.clear();
				continue;
			}
			componenti.add(letta.substring(0, letta.length()-1));
		}
		g.termina();
	}

}
