package analisi;

import org.neo4j.graphdb.DynamicRelationshipType;
import org.neo4j.graphdb.Node;
import org.neo4j.graphdb.Relationship;
import org.neo4j.graphdb.Transaction;
import org.neo4j.index.IndexHits;
import org.neo4j.index.lucene.LuceneIndexService;
import org.neo4j.kernel.EmbeddedGraphDatabase;

import utilities.User;

public class Navigazione {

	private EmbeddedGraphDatabase graphDb;

	private LuceneIndexService index;

	private int manipolazioni=0;
	private Transaction tx;


	public static void main(String argc[]){
		Navigazione n=new Navigazione();
	}

	public Navigazione(){
		System.out.println("Apro il database e avvio la transazione...");
		graphDb = new EmbeddedGraphDatabase( "wp_semantico/" );
		tx=graphDb.beginTx();
		System.out.println("database aperto, transazione avviata. Avvio l'indice...");
		this.index = new LuceneIndexService( graphDb );
		System.out.println("indice avviato");


		Node corrente=null;
		boolean esci=false;
		while(!esci){
			if(corrente==null){
				String nome=User.chiediStringa("Nome della categoria da osservare");
				IndexHits<Node> nodi = index.getNodes("name", nome);

				for(Node n:nodi){
					if(n.hasProperty("idcat"))corrente=n;
				}
				
				if (corrente==null){
					System.out.println("nessun nodo categoria con nome "+nome);
					esci=true;
					continue;
				}
			}
			System.out.println("------nodo corrente: "+corrente.getProperty("name")+" ["+corrente.getProperty("idcat")+"]");

			String opzioni="cerca nome;cerca id pajek;cerca id categoria;ESCI";
			for(Relationship r:corrente.getRelationships(DynamicRelationshipType.withName("SUBCATEGORYOF"),DynamicRelationshipType.withName("BELONGSTO"))){
				if(r.getEndNode().equals(corrente))
				{
					System.out.println("in:"+r.getStartNode().getProperty("name"));
					opzioni+=";in:"+r.getStartNode().getProperty("name");
				}else
				{
					System.out.println("out:"+r.getEndNode().getProperty("name"));
					opzioni+=";out:"+r.getEndNode().getProperty("name");
				}
			}
			System.out.println("Pagine contenute nella categoria:");

			for(Relationship r:corrente.getRelationships(DynamicRelationshipType.withName("BELONGSTO"))){
				System.out.print("-"+r.getOtherNode(corrente).getProperty("name")+" ");
			}

			System.out.println();
			String scelta=User.scegliOpzione(opzioni, "come mi muovo?");

			if(scelta.equals("cerca nome")){corrente=null;continue;}

			if(scelta.equals("cerca id pajek")){
				String idpajek=User.chiediStringa("id pajek della categoria da osservare");
				IndexHits<Node> nodi = index.getNodes("idpajek", idpajek);
				for(Node n:nodi)
					if(n.hasProperty("idcat"))corrente=n;
				if (corrente==null){
					System.out.println("nessun nodo categoria con id pajek "+idpajek);
					esci=true;
					continue;
				}
			}

			if(scelta.equals("cerca id categoria")){
				String idpajek=User.chiediStringa("idcat della categoria da osservare");
				IndexHits<Node> nodi = index.getNodes("idcat", idpajek);
				for(Node n:nodi)
					if(n.hasProperty("idcat"))corrente=n;

				if (corrente==null){
					System.out.println("nessun nodo categoria con idcat "+idpajek);
					esci=true;
					continue;
				}
			}



			if(scelta.equals("ESCI")){esci=true;continue;}

			for(Relationship r:corrente.getRelationships(DynamicRelationshipType.withName("SUBCATEGORYOF"))){
				if(r.getEndNode().equals(corrente))
				{
					if(scelta.equals("in:"+r.getStartNode().getProperty("name"))) corrente=r.getStartNode();
				}else
				{
					if(scelta.equals("out:"+r.getEndNode().getProperty("name"))) corrente=r.getEndNode();
				}
			}

		}

		System.out.println("programma terminato... attendere la chiusura");
		tx.success();
		tx.finish();
		graphDb.shutdown();
		System.exit(1);

	}
}
