package analisi;


import java.io.IOException;
import java.util.HashSet;
import java.util.List;

import org.neo4j.graphdb.Node;
import org.neo4j.graphdb.Transaction;
import org.neo4j.kernel.EmbeddedGraphDatabase;

import utilities.User;
import wrapper.GraphWrapper;


public class PrecalcolaDistanzeCategorie_DIRETTO {


	private GraphWrapper g;
	private int azioni;

	public PrecalcolaDistanzeCategorie_DIRETTO(GraphWrapper g) {
		this.g=g;
	}

	public static void main( String[] args ) throws IOException, InterruptedException
	{

		InserisciCategorieStrumentali.main(null);


		GraphWrapper g=new GraphWrapper("wp_semantico");

		HashSet<String> arrivi=new HashSet<String>();

		arrivi.add("Agriculture");

		arrivi.add("Culture");
		arrivi.add("Arts");

		arrivi.add("Belief");
		arrivi.add("Business");
		arrivi.add("Computing");
		arrivi.add("Education");
		arrivi.add("Geography and places");
		arrivi.add("Health");
		arrivi.add("History and events");
		arrivi.add("Language");
		arrivi.add("Law");
		arrivi.add("Mathematics");
		arrivi.add("Environment");
		arrivi.add("People");

		arrivi.add("Politics");
		arrivi.add("Society");

		arrivi.add("Philosophy");

		arrivi.add("Science");
		arrivi.add("Technology and applied sciences");
		arrivi.add("Sports");

		Node partenza = null;

		for(String nome:arrivi){
			System.out.println("calcolo distanze da "+nome);
			partenza=g.getCategoria(nome);
			if (partenza==null){
				System.out.println("Nessuna pagina trovata per "+nome);
				continue;
			}
		}


		PrecalcolaDistanzeCategorie_DIRETTO mc=new PrecalcolaDistanzeCategorie_DIRETTO(g);
		for(String nome:arrivi){
			System.out.println("calcolo distanze da "+nome);
			partenza=g.getCategoria(nome);
			if (partenza==null){
				System.out.println("Nessuna pagina trovata per "+nome);
				continue;
			}

			mc.percorri(partenza, nome, 1,1);
		}

		g.termina();


	}

	/**
	 * Assegna ricorsivamente a tutte le sottocategorie, ottenute percorrendo le relazioni SUBCATEGORYOF solo 
	 * nella direzione giusta, la proprietà FROMx, dove x è il nome della macrocategoria di riferimento
	 * Il parametro incremento, generalmente posto a 1, indica il valore della distanza tra una categoria 
	 * e una in essa contenuta
	 * */
	public void percorri(Node n,String riferimento,double costo,double incremento){
		if(this.azioni%100==0) g.commit();
		azioni++;
		if(n.hasProperty("name"))
			System.out.println("assegno a "+n.getProperty("name")+" la distanza "+costo+" da "+riferimento);
		else
			return;
		//entro nel nodo se non ha la proprietà o ce l'ha ma è maggiore del costo
		if (Double.parseDouble(n.getProperty("FROM"+riferimento,Double.MAX_VALUE).toString())>costo) 
			n.setProperty("FROM"+riferimento, costo);
		else
			return;

		for(Node sn:g.getCategorieContenute(n)){
			percorri(sn,riferimento,costo+incremento,incremento);
		}
	}


}

