package analisi;

import java.io.File;
import java.util.HashSet;

import org.neo4j.graphdb.Node;
import org.neo4j.graphdb.Transaction;
import org.neo4j.index.lucene.LuceneIndexService;
import org.neo4j.kernel.EmbeddedGraphDatabase;

import utilities.User;

public class RimuoviProprieta {
	public static void main(String argc[]){
		HashSet<String> mantieni=new HashSet<String>();
		for(String p:
			User.chiediStringa("proprietà da eliminare, separate da una virgola").split(",")) 
			mantieni.add(p);

		System.out.println("Avvio il database e apro la transazione...");
		EmbeddedGraphDatabase graph = new EmbeddedGraphDatabase( "wp_semantico/" );
		Transaction tx = graph.beginTx();

		boolean interrotto=true;
		int conta=0;
		for(Node n:graph.getAllNodes()){
			conta++;
			if(conta%100==0){
				tx.success();
				tx.finish();
				tx=graph.beginTx();
				if(new File("blocca.txt").exists()){interrotto = true;break;}
			}
			
			if (!n.hasProperty("name")) continue;
			if (!n.hasProperty("idcat")) continue;
			
			System.out.println();
			System.out.print("["+conta+"] elaboro "+n.getProperty("name"));
			for(String prop:n.getPropertyKeys()){
				if (!mantieni.contains(prop)) continue;
				n.removeProperty(prop);
				System.out.print("-"+prop);
			}
		}
		
		if (interrotto) System.out.println("programma interrotto manualmente");

		System.out.println("Termino...");
		tx.success();
		tx.finish();
		graph.shutdown();
		System.exit(0);


	}
}
