package progetto;

import java.io.File;
import java.io.IOException;
import java.util.Date;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Map.Entry;

import org.neo4j.graphdb.Direction;
import org.neo4j.graphdb.DynamicRelationshipType;
import org.neo4j.graphdb.Node;
import org.neo4j.graphdb.Relationship;

import utilities.Scrittore;
import wrapper.GraphWrapper;

public class AssegnaDistanzeCostiDifferenziati {
	//effettua l'assegnamento delle proprietà FROMx considerando dei costi di 
	//attraversamento diversi nel caso si segua l'orientamento della relazione SUBCATEGORYOF
	public static void main(String argc[]) throws IOException, InterruptedException{


		GraphWrapper g=new GraphWrapper("wp_semantico");


		HashSet<String> arrivi=new HashSet<String>();


		arrivi.add("Agriculture");

		arrivi.add("Culture");
		arrivi.add("Arts");

		arrivi.add("Belief");
		arrivi.add("Business");
		arrivi.add("Computing");
		arrivi.add("Education");
		arrivi.add("Geography and places");
		arrivi.add("Health");
		arrivi.add("History and events");
		arrivi.add("Language");
		arrivi.add("Law");
		arrivi.add("Mathematics");
		arrivi.add("Environment");
		arrivi.add("People");

		arrivi.add("Politics");
		arrivi.add("Society");

		arrivi.add("Philosophy");

		arrivi.add("Science");
		arrivi.add("Technology and applied sciences");
		arrivi.add("Sports");




		Scrittore assegnamento=new Scrittore("assegnazione_categorie.txt");
		boolean interrotto=false;

		for(String macrocat:arrivi){

			System.out.println("inizio analisi distanze da "+macrocat);
			assegnamento.scrivi(new Date().toString()+" assegnamento "+macrocat);
			Node partenza=g.getCategoria(macrocat);
			partenza.setProperty("FROM"+macrocat, 0);
			HashMap<Node,Integer> attuali=new HashMap<Node,Integer>(150000);
			//Languages va considerato come nodo di partenza insieme a Language
			if(macrocat.equals("Language")){
				attuali.put(g.getCategoria("Languages"),0);
				g.getCategoria("Languages").setProperty("FROMLanguage", 0);
			}
			attuali.put(partenza,0);


			if(macrocat.equals("Technology and applied sciences"))attuali.put(partenza,-1);
			if(macrocat.equals("Geography and places"))attuali.put(partenza,-1);
			if(macrocat.equals("History and events"))attuali.put(partenza,-1);

			int azioni=0;

			while(true){
				if(new File("blocca.txt").exists()){interrotto = true;break;}

				assegnamento.scrivi("   "+new Date().toString()+"ne esamino "+attuali.size());
				HashMap<Node,Integer> nuovi=new HashMap<Node,Integer>(150000);
				//metto in nuovi tutti i nodi in relazione con quelli attuali
				int recuperati=0;
				for(Entry<Node, Integer> p:attuali.entrySet()){
					recuperati++;
					System.out.println("["+recuperati+"/"+attuali.size()+"] recupero i nodi collegati a uno di quelli analizzati e con bassa o assente proprietà FROM"+macrocat);

					//lavoro i nodi collegati al contrario dell'orientamento
					for(Relationship r:p.getKey().getRelationships(DynamicRelationshipType.withName( "SUBCATEGORYOF" ),Direction.OUTGOING)){
						if (Integer.parseInt(r.getOtherNode(p.getKey()).getProperty("FROM"+macrocat,Integer.MAX_VALUE).toString())-2>Integer.parseInt(p.getKey().getProperty("FROM"+macrocat).toString()))
							nuovi.put(r.getOtherNode(p.getKey()),p.getValue()+3);
					}
					
					//lavoro i nodi collegati in base all'orientamento
					for(Relationship r:p.getKey().getRelationships(DynamicRelationshipType.withName( "SUBCATEGORYOF" ),Direction.INCOMING)){
						if (Integer.parseInt(r.getOtherNode(p.getKey()).getProperty("FROM"+macrocat,Integer.MAX_VALUE).toString())>Integer.parseInt(p.getKey().getProperty("FROM"+macrocat).toString()))
							nuovi.put(r.getOtherNode(p.getKey()),p.getValue()+1);
					}


				}

				System.out.println("elimino dalla lista di "+nuovi.size()+" i "+attuali.size()+" nodi già analizzati");
				//tra i nuovi ce ne sono di già analizzati, li elimino

				for(Node n:attuali.keySet()){
					nuovi.remove(n);				
				}

				if(nuovi.size()==0) break;

				//ce ne sono di nuovi, gli assegno il costo
				int assegnati=0;
				for(Entry<Node, Integer> n:nuovi.entrySet()){
					assegnati++;
					n.getKey().setProperty("FROM"+macrocat, n.getValue());
					azioni++;
					System.out.println("["+assegnati+"/"+nuovi.size()+"] il nodo "+n.getKey().getProperty("name")+" dista "+n.getValue()+" da "+macrocat);
					if (azioni%1000==0)g.commit();
				}
				System.out.println("Ho "+nuovi.size()+" categorie da analizzare ora");
				//i nuovi nodi diventano quelli vecchi
				attuali.clear();
				for(Entry<Node, Integer> t:nuovi.entrySet())
					attuali.put(t.getKey(), t.getValue());
			}
			if (interrotto) System.out.println("programma interrotto manualmente");
			g.commit();
		}
		if (interrotto) System.out.println("programma interrotto manualmente");
		assegnamento.chiudi();

		g.termina();
	}
}
