package progetto;

import java.io.File;
import java.io.IOException;
import java.util.HashSet;
import java.util.Map.Entry;

import org.neo4j.graphdb.Node;

import utilities.Lettore;
import utilities.Scrittore;
import wrapper.GraphWrapper;
import distanze.Misuratore;

public class AssegnaSpecificiAMacrocategorie {
	//assegna dei nodi specifici alle macrocategorie, prendendo i nomi delle pagine su cui iterare da un file
	public static void main( String[] args ) throws IOException
	{


		GraphWrapper g=new GraphWrapper("wp_semantico");

		HashSet<String> arrivi=new HashSet<String>();
		arrivi.add("Agriculture");
		arrivi.add("Applied sciences");
		arrivi.add("Arts");
		arrivi.add("Belief");
		arrivi.add("Business");
		arrivi.add("Computing");
		arrivi.add("Culture");
		arrivi.add("Education");
		arrivi.add("Environment");
		arrivi.add("Geography");
		arrivi.add("Health");
		arrivi.add("History");

		arrivi.add("Humanities");
		arrivi.add("Language");
		arrivi.add("Law");
		arrivi.add("Life");
		arrivi.add("Mathematics");
		arrivi.add("Nature");
		arrivi.add("People");
		arrivi.add("Politics");
		arrivi.add("Science");

		arrivi.add("Society");
		arrivi.add("Technology");



		Node partenza = null;
		//String nome=User.chiediStringa("pagina di partenza");

		Scrittore uncat=new Scrittore("SUBpagine_inclassificabili.txt");
		Scrittore onecat=new Scrittore("SUBpagine_classificate.txt");
		Scrittore mulcat=new Scrittore("SUBpagine_ambigue.txt");
		Scrittore err=new Scrittore("SUBerrori.txt");

		int azioni=0;

		boolean interrotto=false;

		int articoliElaborati=0;
		Misuratore m=new Misuratore(arrivi,g);
		Lettore lt=new Lettore("pagine_inclassificabili.txt");
		String letta;
		Node np;
		while((letta=lt.leggi())!=null){
			np=g.getPagina(letta.split(">")[1]);
			if(np==null)continue;
			azioni++;
			if (azioni%100==0){
				g.commit();
				System.out.println("nodo "+azioni);
			}
			if(new File("blocca.txt").exists()){interrotto = true;break;}
			if(np.hasProperty("idcat")) continue;


			if (!np.hasProperty("name"))continue;
			String nome=np.getProperty("name").toString();
			System.out.println(azioni+" itero su "+nome);
			if (!np.hasProperty("idpag"))continue;


			System.out.println(azioni+" analizzo "+nome);

			//è un nodo senza appartenenze? Lo salto
			if(!g.getCategorieAppartenenza(np).iterator().hasNext()) continue;

			//			//è una disambigua? Se sì la salto
			//			//TODO non dovrebbero esserci, sono state eliminate in precedenza
			//			if(g.getCategorieAppartenenza(np).iterator().next().getProperty("name").toString().contains("isambiguation")){
			//				continue;				
			//			}


			HashSet<String> appartenenze=new HashSet<String>();
			Double distanzaMin=Double.MAX_VALUE;
			articoliElaborati++;
			System.out.println("   ELABORATI: "+articoliElaborati);
			partenza=np;

			//è un nodo orfano? lo elimino e lo salto

			if(!np.getRelationships().iterator().hasNext()){
				System.out.println("ELIMINO l'orfano "+np.getProperty("name"));
				err.scrivi("ELIMINO l'orfano "+np.getProperty("name"));
				g.elimina(np);
				continue;
			}



			if(g.getCategorieAppartenenza(partenza).size()==0) err.scrivi("Errore, la pagina "+nome+" non è categorizzata");

			//			for(Node ca:g.getCategorieAppartenenza(partenza)){
			//				System.out.println();
			//				for(String prop:ca.getPropertyKeys()){
			//					System.out.println(prop+":"+ca.getProperty(prop));
			//				}
			//			}


			for(Entry<String, Double> prc:m.getDistanze(partenza).entrySet()){
				System.out.println("arrivo a "+prc.getKey()+" in "+prc.getValue()+" passi");
				//tre casi:
				//la lunghezza è maggiore del massimo, lo salto
				if(prc.getValue()>distanzaMin) continue;
				//la lunghezza è uguale, aggiungo l'arrivo al Set
				if(prc.getValue().compareTo(distanzaMin)==0)
					appartenenze.add(prc.getKey());
				//la lunghezza è minore, resetto il set e la abbasso
				if(prc.getValue()<distanzaMin){
					appartenenze.clear();
					appartenenze.add(prc.getKey().toString());
					distanzaMin=prc.getValue();
				}
			}

			//ora il set appartenenze contiene l'elenco delle macrocategorie più vicine
			//ora ho il set delle appartenenze.
			//è vuoto?
			if(appartenenze.size()==0){
				System.out.println("non categorizzato:"+np.getProperty("idpag").toString()+">"+nome);
				uncat.scrivi(np.getProperty("idpag").toString()+">"+nome);
			}

			//ha un solo elemento ?
			if(appartenenze.size()==1){
				System.out.println("categorizzo "+np.getProperty("idpag").toString()+">"+nome+">"+appartenenze.iterator().next());
				onecat.scrivi(np.getProperty("idpag").toString()+">"+nome+">"+appartenenze.iterator().next());
			}

			//ha più elementi ?
			if(appartenenze.size()>1){
				String elementi="";
				for(String el:appartenenze)elementi+=el+"|";
				System.out.println("categorie multiple:"+np.getProperty("idpag").toString()+">"+nome+">"+elementi);
				mulcat.scrivi(np.getProperty("idpag").toString()+">"+nome+">"+elementi);
			}

		}

		if (interrotto) System.out.println("programma interrotto manualmente");
		err.chiudi();
		uncat.chiudi();
		mulcat.chiudi();
		onecat.chiudi();
		g.termina();

	}

}
