package progetto;

import java.io.File;
import java.io.IOException;
import java.text.DecimalFormat;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Map.Entry;

import org.neo4j.graphdb.Node;

import utilities.Scrittore;
import wrapper.GraphWrapper;
import distanze.Misuratore;

public class AssegnamentoProbabilisticoParziale {


	//esegue l'assegnamento probabilistico, ma considera infinita 
	//la distanza dalle macrocategorie di cui non trova la proprietà FROMx
	//serve a usare le proprietà FROmx assegnate da PrecalcolaDistanzeCategorie_DIRETTO

	public static void main( String[] args ) throws IOException{


		GraphWrapper g=new GraphWrapper("wp_semantico");

		HashSet<String> arrivi=new HashSet<String>();

		arrivi.add("Agriculture");

		arrivi.add("Culture");
		arrivi.add("Arts");

		arrivi.add("Belief");
		arrivi.add("Business");
		arrivi.add("Computing");
		arrivi.add("Education");
		arrivi.add("Geography and places");
		arrivi.add("Health");
		arrivi.add("History and events");
		arrivi.add("Language");
		arrivi.add("Law");
		arrivi.add("Mathematics");
		arrivi.add("Environment");
		arrivi.add("People");

		arrivi.add("Politics");
		arrivi.add("Society");

		arrivi.add("Philosophy");

		arrivi.add("Science");
		arrivi.add("Technology and applied sciences");
		arrivi.add("Sports");

		Node partenza = null;
		//String nome=User.chiediStringa("pagina di partenza");

		Scrittore uncat=new Scrittore("pagine_inclassificabili_s2.txt");
		Scrittore cat=new Scrittore("pagine_classificate_s2.txt");

		Scrittore err=new Scrittore("errori.txt");

		int azioni=0;

		boolean interrotto=false;

		int articoliElaborati=0;
		Misuratore m=new Misuratore(arrivi,g);

		for(Node np:g.getAllNodes()){

			azioni++;
			if (azioni%100==0){
				g.commit();
				System.out.println("nodo "+azioni);
			}
			if(new File("blocca.txt").exists()){interrotto = true;break;}
			if(np.hasProperty("idcat")) continue;


			if (!np.hasProperty("name"))continue;
			String nome=np.getProperty("name").toString();

			if (!np.hasProperty("idpag"))continue;


			//System.out.println(azioni+" analizzo "+nome);

			//è un nodo senza appartenenze? Lo salto
			if(!g.getCategorieAppartenenza(np).iterator().hasNext()) continue;

			//è una disambigua? Se sì la salto
			//TODO non dovrebbero esserci, sono state eliminate in precedenza
			if(g.getCategorieAppartenenza(np).iterator().next().getProperty("name").toString().contains("isambiguation")){
				continue;				
			}


			HashSet<String> appartenenze=new HashSet<String>();
			Double distanzaMin=Double.MAX_VALUE;
			articoliElaborati++;

			//salto per riprendere il lavoro interrotto e spezzettarlo in sessioni
			if(articoliElaborati<0) continue;
			System.out.println("   ELABORATI: "+articoliElaborati);
			partenza=np;

			//è un nodo orfano? lo elimino e lo salto

			if(!np.getRelationships().iterator().hasNext()){
				System.out.println("ELIMINO l'orfano "+np.getProperty("name"));
				err.scrivi("ELIMINO l'orfano "+np.getProperty("name"));
				g.elimina(np);
				continue;
			}



			if(g.getCategorieAppartenenza(partenza).size()==0) err.scrivi("Errore, la pagina "+nome+" non è categorizzata");

			//per ogni categoria di appartenenza, trovo le macrocategorie più vicine

			HashMap<String,Double> percentuali= new HashMap<String,Double>();

			for(Node categoria:g.getCategorieAppartenenza(np)){
				HashMap<String,Double> distanze=new HashMap<String,Double>();
				double minima=Double.MAX_VALUE;
				for(String prop:categoria.getPropertyKeys()){
					if(prop.startsWith("FROM")) {
						if(Double.parseDouble(categoria.getProperty(prop).toString())<minima){
							minima=Double.parseDouble(categoria.getProperty(prop).toString());
							distanze.clear();
							distanze.put(prop.substring(4), minima);
						}
						if(Double.parseDouble(categoria.getProperty(prop).toString())==minima)
							distanze.put(prop.substring(4), minima);
					}
				}
				//System.out.println();
				//System.out.println("Analisi della categoria "+categoria.getProperty("name"));
				System.out.print("  ");
				for(Entry<String, Double> prc:distanze.entrySet()){
					//System.out.print(prc.getKey().getProperty("name")+":"+prc.getValue()+" passi ");
					//tre casi:
					//la lunghezza è maggiore del massimo, lo salto
					if(prc.getValue()>distanzaMin) continue;
					//la lunghezza è uguale, aggiungo l'arrivo al Set
					if(prc.getValue().compareTo(distanzaMin)==0)
						appartenenze.add(prc.getKey());
					//la lunghezza è minore, resetto il set e la abbasso
					if(prc.getValue()<distanzaMin){
						appartenenze.clear();
						appartenenze.add(prc.getKey());
						distanzaMin=prc.getValue();
					}
				}

				//ora il set appartenenze contiene l'elenco delle macrocategorie più vicine alla categoria

				//fine del ciclo delle categorie di appartenenza: inserisco le appartenenze nella hashmap
				int elementi=appartenenze.size();
				for(String macrocat:appartenenze){
					//se l'elemento non esiste lo creo, altrimenti aggiorno
					if(!percentuali.containsKey(macrocat))
						percentuali.put(macrocat, (double)((double)1/(double)elementi));
					else
						percentuali.put(macrocat, (double)((double)1/(double)elementi)+percentuali.get(macrocat).doubleValue());

				}
			}
			//la hasmpa è vuota?
			if(percentuali.isEmpty()){
				uncat.scrivi(np.getProperty("idpag").toString()+">"+nome);
				continue;
			}
			//ora ho la hashmap degli assegnamenti, la normalizzo e segno i valori
			double totale=0;
			for(Entry<String, Double> perc:percentuali.entrySet()){
				totale+=perc.getValue().doubleValue();
			}
			String rp="";
			for(Entry<String, Double> perc:percentuali.entrySet()){
				rp+=perc.getKey()+":"+new DecimalFormat("###.##").format((perc.getValue()/totale)*100)+";";
			}
			String risultato=np.getProperty("idpag").toString()+">"+nome+">"+rp;
			System.out.println(risultato);
			cat.scrivi(risultato);


		}

		if (interrotto) System.out.println("programma interrotto manualmente");
		err.chiudi();
		uncat.chiudi();
		cat.chiudi();
		g.termina();

	}


}
