package progetto;

import java.io.IOException;
import java.util.HashSet;

import org.neo4j.graphdb.Node;

import utilities.Lettore;
import utilities.Scrittore;
import utilities.User;
import wrapper.GraphWrapper;

public class EstraiCategorieOrfane {
	public static void main(String argc[]) throws IOException{
		GraphWrapper g=new GraphWrapper("wp_semantico");
		Lettore l=new Lettore("categorizzaci.txt");
		String letta;
		HashSet<Node> orfane=new HashSet<Node>(50000);
		while((letta=l.leggi())!=null){
			if(letta.contains("Undergorund"))
				System.out.println();
			if(l.getNumeroRiga()%1000==0)System.out.println(l.getNumeroRiga());
			if (!letta.contains(">")) continue;
			orfane.addAll(g.getCategorieAppartenenza(g.getNodes("idpag", letta.split(">")[0]).iterator().next()));
		}
		System.out.println("Lettura file terminata, ci sono "+orfane.size()+" categorie orfane");
		System.out.println("cerco quali sono orfane direttamente e quali indirettamente");

		Scrittore od=new Scrittore("orfane_dirette.txt");
		Scrittore oi=new Scrittore("orfane_indirette.txt");

		Scrittore err=new Scrittore("errori.txt");


		for(Node cat:orfane){
			try{

				if (g.getCategorieAppartenenza(cat).size()==0){
					od.scrivi(cat.getProperty("idcat")+">"+cat.getProperty("name"));
					System.out.println(cat.getProperty("idcat")+">"+cat.getProperty("name"));
				}
				else{
					oi.scrivi(cat.getProperty("idcat")+">"+cat.getProperty("name"));
					System.out.println("INDIRETTA:"+cat.getProperty("idcat")+">"+cat.getProperty("name"));		
				}
			}
			catch(org.neo4j.graphdb.NotFoundException e){
				err.scrivi("la pagina "+cat.getProperty("name")+" ("+cat.getProperty("idpag")+") contiene delle pagine!");
			}
		}
		
		err.chiudi();
		od.chiudi();
		oi.chiudi();
		l.chiudi();
		g.termina();

	}
}
