package progetto;



import java.io.IOException;
import java.util.HashSet;
import java.util.List;

import org.neo4j.graphalgo.shortestpath.Dijkstra;
import org.neo4j.graphalgo.shortestpath.SingleSourceSingleSinkShortestPath;
import org.neo4j.graphalgo.shortestpath.std.DoubleAdder;
import org.neo4j.graphalgo.shortestpath.std.DoubleComparator;
import org.neo4j.graphalgo.shortestpath.std.DoubleEvaluator;
import org.neo4j.graphdb.Direction;
import org.neo4j.graphdb.DynamicRelationshipType;
import org.neo4j.graphdb.GraphDatabaseService;
import org.neo4j.graphdb.Node;
import org.neo4j.graphdb.Relationship;
import org.neo4j.graphdb.Transaction;
import org.neo4j.index.IndexService;
import org.neo4j.index.lucene.LuceneIndexService;
import org.neo4j.kernel.EmbeddedGraphDatabase;

import distanze.Misuratore;

import utilities.Lettore;
import utilities.Scrittore;
import utilities.User;
import wrapper.GraphWrapper;


public class EstraiRipartizioni{
	public static void main( String[] args ) throws IOException
	{

		GraphWrapper g=new GraphWrapper("wp_semantico");

		HashSet<String> arrivi=new HashSet<String>();
		arrivi.add("Agriculture");
		arrivi.add("Applied sciences");
		arrivi.add("Arts");
		arrivi.add("Belief");
		arrivi.add("Business");
		arrivi.add("Chronology");
		arrivi.add("Computing");
		arrivi.add("Culture");
		arrivi.add("Education");
		arrivi.add("Environment");
		arrivi.add("Geography");
		arrivi.add("Health");
		arrivi.add("History");

		arrivi.add("Humanities");
		arrivi.add("Language");
		arrivi.add("Law");
		arrivi.add("Life");
		arrivi.add("Mathematics");
		arrivi.add("Nature");
		arrivi.add("People");
		arrivi.add("Politics");
		arrivi.add("Science");

		arrivi.add("Society");
		arrivi.add("Technology");

		int azioni=0;
		Scrittore uncat=new Scrittore("pagine_inclassificabili.txt");
		Scrittore onecat=new Scrittore("pagine_classificate.txt");
		Scrittore mulcat=new Scrittore("pagine_ambigue.txt");

		System.out.println("avvio l'iterazione...");

		for(Node pagina:g.getAllNodes()){
			azioni++;
			if (azioni%100==0)g.commit();

			if(!pagina.hasProperty("idpag"))continue;
			System.out.println("analizzo "+pagina.getProperty("name"));
			HashSet <String> appartenenza=new HashSet<String>();
			int minimaDistanza=Integer.MAX_VALUE;
			for(Node cat:g.getCategorieAppartenenza(pagina)){
				//ora ho l'elenco delle categorie di appartenenza
				//per ognuna ottengo l'elenco delle macrocategorie di appartenenza e assegno la pagina al set delle appartenenze
				for(String prop:cat.getPropertyKeys()){
					if(!prop.startsWith("FROM")) continue;
					int dist=Integer.parseInt(cat.getProperty(prop).toString());
					//tre casi: la distanza è minore, maggiore o uguale di quella del set
					if (dist<minimaDistanza){
						minimaDistanza=dist;
						appartenenza.clear();
						appartenenza.add(prop.substring(4));
					}
					if(dist==minimaDistanza) appartenenza.add(prop.substring(4));
					if(dist>minimaDistanza)continue;
				}
			}
			//ora ho il set delle appartenenze.
			//è vuoto?
			if(appartenenza.size()==0){
				//è un redirect?
				if (!pagina.getRelationships().iterator().hasNext()){
					pagina.delete();
					continue;
				}
				System.out.println("non categorizzato:"+pagina.getProperty("idpag").toString()+">"+pagina.getProperty("name").toString());
				uncat.scrivi(pagina.getProperty("idpag").toString()+">"+pagina.getProperty("name").toString());
			}
			//ha un solo elemento ?
			if(appartenenza.size()==1){
				System.out.println("categorizzo "+pagina.getProperty("idpag").toString()+">"+pagina.getProperty("name").toString()+">"+appartenenza.iterator().next());
				onecat.scrivi(pagina.getProperty("idpag").toString()+">"+pagina.getProperty("name").toString()+">"+appartenenza.iterator().next());
			}
			//ha più elementi ?
			if(appartenenza.size()>1){
				String elementi="";
				for(String el:appartenenza)elementi+=el+"|";
				System.out.println("categoriue multiple:"+pagina.getProperty("idpag").toString()+">"+pagina.getProperty("name").toString()+">"+elementi);
				mulcat.scrivi(pagina.getProperty("idpag").toString()+">"+pagina.getProperty("name").toString()+">"+elementi);
			}

		}

		uncat.chiudi();
		mulcat.chiudi();
		onecat.chiudi();
		g.termina();

	}
}



