package progetto;

import java.io.File;
import java.io.IOException;
import java.util.Date;
import java.util.HashMap;
import java.util.Map;

import org.neo4j.graphdb.DynamicRelationshipType;
import org.neo4j.graphdb.GraphDatabaseService;
import org.neo4j.graphdb.Node;
import org.neo4j.graphdb.Transaction;
import org.neo4j.index.IndexService;
import org.neo4j.index.lucene.LuceneIndexBatchInserter;
import org.neo4j.index.lucene.LuceneIndexBatchInserterImpl;
import org.neo4j.index.lucene.LuceneIndexService;
import org.neo4j.kernel.EmbeddedGraphDatabase;
import org.neo4j.kernel.impl.batchinsert.BatchInserter;
import org.neo4j.kernel.impl.batchinsert.BatchInserterImpl;

import utilities.Lettore;
import utilities.Scrittore;
import utilities.User;

public class RigeneraCategorie {



	/*
	 * Leggo l'elenco deglle categorie orfane, e per ognuna cerco l'elemento in links.txt (o meglio, nell'indice costruito a partire da links.txt)
	 * Se appartiene a un redirect, vado al prossimo orfano
	 * Se non appartiene a un redirect cerco la categoria e lo lego ad essa
	 * Se non esiste la categoria lo segno in un log di errore
	 * */
	public static void main(String argc[]) throws IOException{



		System.out.println("Apertura files...");
		Lettore orfane=new Lettore("categorie_orfane.txt");



		//questo if serve a spezzettare il lavoro in più parti, e va usato insieme al file blocca.txt
		if(true){

			System.out.println("apro il database ausiliario");


			//creo l'oggetto per inserire i dati senza transazioni (modalità batch)
			BatchInserter inserter = new BatchInserterImpl( "aux2/", BatchInserterImpl.loadProperties( "neo4j.props" ) );
			//creo il servizio di indicizzazione per i nodi
			LuceneIndexBatchInserter indexService = new LuceneIndexBatchInserterImpl( inserter );



			//		GraphDatabaseService aux = new EmbeddedGraphDatabase( "aux/" );
			//
			//		System.out.println("avvio l'indice ausiliario");
			//		IndexService indexaux = new LuceneIndexService( aux );
			//		System.out.println("apro la transazione ausiliaria");
			//		Transaction txaux = aux.beginTx();


			//memorizzo tutte le coppie articolo->link nel db ausiliario
			System.out.println("Avvio idratazione del database");
			String rigaLink;
			int auxact=0;
			boolean interrotto=false;
			Map<String,Object> properties = new HashMap<String,Object>();
			Date inizio=new Date();
			while((rigaLink=orfane.leggi())!=null){
				auxact++;
				//questa riga serve a saltare a una certa riga del file in modo da riprendere il lavoro interrotto
				if(auxact<0)continue;
				System.out.println(rigaLink);
				if(auxact%5000==0)if(new File("blocca.txt").exists()){interrotto = true;break;}
				if(auxact%5000==0){
					System.out.println("idrato db ausiliario: "+auxact+" - "+new Date().toString());
					Date arrivo=new Date((((new Date().getTime()-inizio.getTime())/(auxact/1000))*40000)+inizio.getTime());
					System.out.println("    fine prevista per "+arrivo.toString());
				}

				properties.clear();


				String[] parti = rigaLink.split(">");
				parti[1]=parti[1].replace("_", " ");
				parti[1]=parti[1].replace("&amp;", "&");
				parti[1]=parti[1].replace("[^-a-zA-Z 0-9_&!?^=$()\\[\\]{}\\\\/]", "");

				properties.put("id", rigaLink.split(">")[0]);
				long node = inserter.createNode( properties );



				indexService.index( node, "id",rigaLink.split(">")[0]);   
				indexService.index( node, "name",rigaLink.split(">")[1]);   
				//			
				//			Node n=aux.createNode();
				//			n.setProperty("from", appartenenza.split(">")[0]);
				//			n.setProperty("to", appartenenza.split(">")[1]);
				//			indexaux.index(n, "from",appartenenza.split(">")[0]);
				//			indexaux.index(n, "to",appartenenza.split(">")[1]);
			}

			orfane.chiudi();
			if(interrotto){
				System.out.println("programma interrotto manualmente");
				//			txaux.failure();
				//			txaux.finish();
				//			aux.shutdown();
				indexService.optimize();
				indexService.shutdown();
				inserter.shutdown();
				System.exit(1);
			}
			System.out.println("ho memorizzato e indicizzato tutte le informazioni from->to");
			indexService.optimize();
			indexService.shutdown();
			inserter.shutdown();
		}


		System.out.println("riapro il database, non più in modalità batch");

		GraphDatabaseService aux = new EmbeddedGraphDatabase( "aux2/" );

		System.out.println("avvio l'indice ausiliario");
		IndexService indexaux = new LuceneIndexService( aux );
		System.out.println("apro la transazione ausiliaria");
		Transaction txaux = aux.beginTx();




		System.out.println("apro il database");

		GraphDatabaseService graphDb = new EmbeddedGraphDatabase( "wp_semantico/" );

		System.out.println("avvio l'indice");
		IndexService index = new LuceneIndexService( graphDb );
		System.out.println("apro la transazione");
		Transaction tx = graphDb.beginTx();


		int azioni=0;
		String link;
		Lettore links=new Lettore("links.txt");
		Scrittore err=new Scrittore("Errori rigenerazione.txt");

		while((link=links.leggi())!=null){
			azioni++;
			if(new File("blocca.txt").exists())break;
			if(azioni%100==0){
				System.out.println("azione "+azioni);
				tx.success();
				tx.finish();
				tx=graphDb.beginTx();
				txaux.success();
				txaux.finish();
				txaux=aux.beginTx();

			}

			if (indexaux.getSingleNode("id",link.split(">")[0])!=null){
				Node questaPagina=index.getSingleNode("idcat",link.split(">")[0]);
				Node arrivo=null;
				for(Node n2:index.getNodes("name", link.split(">")[1])) if (n2.hasProperty("idcat")) arrivo=n2;
				if (arrivo==null){
					System.out.println("categoria di appartenenza "+link.split(">")[1] +" inesistente");
					continue;
				}
				if(arrivo.equals(questaPagina)){
					System.out.println("Categoria che si autocontiene in "+link);
					User.chiediStringa("letto?");
					continue;
				}
				System.out.println("categorizzo "+questaPagina.getProperty("name")+" in "+link.split(">")[1]);
				questaPagina.createRelationshipTo(arrivo, DynamicRelationshipType.withName( "SUBCATEGORYOF" ));
			}

		}




		System.out.println("fatto, chiudo...");
		err.chiudi();
		orfane.chiudi();

		tx.success();
		tx.finish();
		graphDb.shutdown();

		System.exit(1);
	}

}
