package progetto;

import java.io.File;
import java.io.IOException;
import java.text.DecimalFormat;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Set;
import java.util.Map.Entry;

import org.neo4j.graphdb.Node;

import utilities.Scrittore;
import wrapper.GraphWrapper;


public class AssegnamentoProbabilistico {
	public static void main( String[] args ) throws IOException
	{


		GraphWrapper g=new GraphWrapper("wp_semantico");

		HashSet<String> arrivi=new HashSet<String>();

		//		arrivi.add("Agriculture");
		//		arrivi.add("Applied sciences");
		//		arrivi.add("Arts");
		//		arrivi.add("Belief");
		//		arrivi.add("Business");
		//		arrivi.add("Computing");
		//		arrivi.add("Culture");
		//		arrivi.add("Education");
		//		arrivi.add("Environment");
		//		arrivi.add("Geography");
		//		arrivi.add("Health");
		//		arrivi.add("History");
		//
		//		arrivi.add("Humanities");
		//		arrivi.add("Language");
		//		arrivi.add("Law");
		//		arrivi.add("Life");
		//		arrivi.add("Mathematics");
		//		arrivi.add("Nature");
		//		arrivi.add("People");
		//		arrivi.add("Politics");
		//		arrivi.add("Science");
		//
		//		arrivi.add("Society");
		//		arrivi.add("Technology");


		//		g.categorizzaIn(g.getCategoria("Chronology"),g.getCategoria("History"));
		//		g.categorizzaIn(g.getCategoria("Natural sciences"),g.getCategoria("Science"));
		//		g.elimina(g.getCategoria("Nature and environment"));
		//		g.elimina(g.getCategoria("Politics and society"));
		//		g.elimina(g.getCategoria("Culture and the arts"));
		//		
		//		
		//		Node n=g.createNode();
		//
		//		n.setProperty("name", "Geography and places");
		//		n.setProperty("idcat", "400000004");		
		//
		//		g.indicizza(n, "name", "Geography and places");
		//		g.indicizza(n, "idcat", "400000004");
		//
		//		g.categorizzaIn(g.getCategoria("Geography"),n);
		//		g.categorizzaIn(g.getCategoria("Places"),n);
		//		
		//		
		//		n=g.createNode();
		//
		//		n.setProperty("name", "History and events");
		//		n.setProperty("idcat", "400000005");		
		//
		//		g.indicizza(n, "name", "History and events");
		//		g.indicizza(n, "idcat", "400000005");
		//
		//		g.categorizzaIn(g.getCategoria("History"),n);
		//		g.categorizzaIn(g.getCategoria("Events"),n);
		//		
		//		
		//		g.commit();


		arrivi.add("Agriculture");

		arrivi.add("Culture");
		arrivi.add("Arts");

		arrivi.add("Belief");
		arrivi.add("Business");
		arrivi.add("Computing");
		arrivi.add("Education");
		arrivi.add("Geography and places");
		arrivi.add("Health");
		arrivi.add("History and events");
		arrivi.add("Language");
		arrivi.add("Law");
		arrivi.add("Mathematics");
		arrivi.add("Environment");
		arrivi.add("People");

		arrivi.add("Politics");
		arrivi.add("Society");

		arrivi.add("Philosophy");

		arrivi.add("Science");
		arrivi.add("Technology and applied sciences");
		arrivi.add("Sports");

		Node partenza = null;
		//String nome=User.chiediStringa("pagina di partenza");

		Scrittore uncat=new Scrittore("pagine_inclassificabili_penalizzaBY.txt");
		Scrittore cat=new Scrittore("pagine_classificate_penalizzaBY.txt");

		Scrittore err=new Scrittore("errori.txt");

		int azioni=0;

		boolean interrotto=false;

		int articoliElaborati=0;


		for(Node np:g.getAllNodes()){

			azioni++;
			if (azioni%100==0){
				g.commit();
				System.out.println("nodo "+azioni);
			}
			if (azioni%100000==0)
				try {
					Thread.sleep(5000);
				} catch (InterruptedException e) {
					e.printStackTrace();
				}
				if(new File("blocca.txt").exists()){interrotto = true;break;}
				if(np.hasProperty("idcat")) continue;


				if (!np.hasProperty("name"))continue;
				String nome=np.getProperty("name").toString();

				if (!np.hasProperty("idpag"))continue;


				//System.out.println(azioni+" analizzo "+nome);

				//è un nodo senza appartenenze? Lo salto
				if(!g.getCategorieAppartenenza(np).iterator().hasNext()) continue;

				//è una disambigua? Se sì la salto
				//TODO non dovrebbero esserci, sono state eliminate in precedenza
				if(g.getCategorieAppartenenza(np).iterator().next().getProperty("name").toString().contains("isambiguation")){
					continue;				
				}


				HashSet<String> appartenenze=new HashSet<String>();
				Double distanzaMin=Double.MAX_VALUE;
				articoliElaborati++;

				//salto per riprendere il lavoro interrotto e spezzettarlo in sessioni
				if(articoliElaborati<0) continue;
				System.out.println("   ELABORATI: "+articoliElaborati);
				partenza=np;

				//è un nodo orfano? lo elimino e lo salto

				if(!np.getRelationships().iterator().hasNext()){
					System.out.println("ELIMINO l'orfano "+np.getProperty("name"));
					err.scrivi("ELIMINO l'orfano "+np.getProperty("name"));
					g.elimina(np);
					continue;
				}



				if(g.getCategorieAppartenenza(partenza).size()==0) err.scrivi("Errore, la pagina "+nome+" non è categorizzata");

				//per ogni categoria di appartenenza, trovo le macrocategorie più vicine

				HashMap<String,Double> percentuali= new HashMap<String,Double>();

				for(Node categoria:g.getCategorieAppartenenza(np)){
					//System.out.println();
					//System.out.println("Analisi della categoria "+categoria.getProperty("name"));
					System.out.print("  ");
					for(Entry<String, Double> prc:getDistanze(categoria,arrivi,g).entrySet()){
						//System.out.print(prc.getKey().getProperty("name")+":"+prc.getValue()+" passi ");
						//tre casi:
						//la lunghezza è maggiore del massimo, lo salto
						if(prc.getValue()>distanzaMin) continue;
						//la lunghezza è uguale, aggiungo l'arrivo al Set
						if(prc.getValue().compareTo(distanzaMin)==0)
							appartenenze.add(prc.getKey());
						//la lunghezza è minore, resetto il set e la abbasso
						if(prc.getValue()<distanzaMin){
							appartenenze.clear();
							appartenenze.add(prc.getKey());
							distanzaMin=prc.getValue();
						}
					}

					//ora il set appartenenze contiene l'elenco delle macrocategorie più vicine alla categoria

					//fine del ciclo delle categorie di appartenenza: inserisco le appartenenze nella hashmap
					int elementi=appartenenze.size();
					for(String macrocat:appartenenze){
						//se l'elemento non esiste lo creo, altrimenti aggiorno
						if(!percentuali.containsKey(macrocat))
							percentuali.put(macrocat, (double)((double)1/(double)elementi));
						else
							percentuali.put(macrocat, (double)((double)1/(double)elementi)+percentuali.get(macrocat).doubleValue());

					}
				}
				//la hasmap è vuota?
				if(percentuali.isEmpty()){
					uncat.scrivi(np.getProperty("idpag").toString()+">"+nome);
					continue;
				}
				//ora ho la hashmap degli assegnamenti, la normalizzo e segno i valori
				double totale=0;
				for(Entry<String, Double> perc:percentuali.entrySet()){
					totale+=perc.getValue().doubleValue();
				}
				String rp="";
				for(Entry<String, Double> perc:percentuali.entrySet()){
					rp+=perc.getKey()+":"+new DecimalFormat("###.##").format((perc.getValue()/totale)*100)+";";
				}
				String risultato=np.getProperty("idpag").toString()+">"+nome+">"+rp;
				System.out.println(risultato);
				cat.scrivi(risultato);


		}

		if (interrotto) System.out.println("programma interrotto manualmente");
		err.chiudi();
		uncat.chiudi();
		cat.chiudi();
		g.termina();

	}
	public static HashMap<String, Double> getDistanze(Node partenza,Set<String> arrivi,GraphWrapper g) {
		HashMap<String,Double> risultato=new HashMap<String,Double>();

		for(String nc:arrivi){
			Node a=g.getCategoria(nc);			
			double minDist=Double.MAX_VALUE;

			HashMap<String,Double> aggiunta=new HashMap<String,Double> ();

			for(Node p:g.getCategorieAppartenenza(partenza)){
				double dist=getDistanza(p, a);
				if (dist<0) continue;
				if (dist>minDist) continue;
				//se è uguale, me ne basta uno
				if(dist==minDist)continue;
				//sono qua, quindi è minore
				minDist=dist;
				aggiunta.clear();
				aggiunta.put(a.getProperty("name").toString(), dist);

			}
			risultato.putAll(aggiunta);
		}
		return risultato;
	}
	public static double getDistanza(Node partenza,Node arrivo){
		if (partenza==null || arrivo==null) return -1;
		//se la categoria di partenza ha la proprietà FROM... la uso
		//altrimenti la calcolo e la imposto
		if(partenza.hasProperty("FROM"+arrivo.getProperty("name"))){
			return Double.parseDouble(partenza.getProperty("FROM"+arrivo.getProperty("name")).toString());
		}
		return -1;
	}
}
