package progetto;

import java.io.File;
import java.io.IOException;
import java.text.DecimalFormat;
import java.util.HashMap;
import java.util.Map.Entry;

import org.neo4j.graphdb.Node;

import utilities.Scrittore;
import wrapper.GraphWrapper;

public class AssegnamentoProbabilisticoParzialeQuote {


	//esegue l'assegnamento probabilistico, ma considera infinita 
	//la distanza dalle macrocategorie di cui non trova la proprietà FROMx
	//serve a usare le proprietà FROmx assegnate da PrecalcolaDistanzeCategorie_DIRETTO

	public static void main( String[] args ) throws IOException{


		GraphWrapper g=new GraphWrapper("wp_semantico");

		Node partenza = null;
		//String nome=User.chiediStringa("pagina di partenza");

		Scrittore uncat=new Scrittore("pagine_inclassificabili_quote_nuovo2.txt");
		Scrittore cat=new Scrittore("pagine_classificate_quote_nuovo2.txt");

		Scrittore err=new Scrittore("errori.txt");

		int azioni=0;

		boolean interrotto=false;

		int articoliElaborati=0;

		for(Node np:g.getAllNodes()){

			azioni++;
			if (azioni%100==0){
				g.commit();
				System.out.println("nodo "+azioni);
			}
			if(new File("blocca.txt").exists()){interrotto = true;break;}
			if(np.hasProperty("idcat")) continue;


			if (!np.hasProperty("name"))continue;
			String nome=np.getProperty("name").toString();

			if (!np.hasProperty("idpag"))continue;


			//System.out.println(azioni+" analizzo "+nome);

			//è un nodo senza appartenenze? Lo salto
			if(!g.getCategorieAppartenenza(np).iterator().hasNext()) continue;

			//è una disambigua? Se sì la salto
			//TODO non dovrebbero esserci, sono state eliminate in precedenza
			if(g.getCategorieAppartenenza(np).iterator().next().getProperty("name").toString().contains("isambiguation")){
				continue;				
			}


			articoliElaborati++;

			//salto per riprendere il lavoro interrotto e spezzettarlo in sessioni
			if(articoliElaborati<0) continue;
			System.out.println("   ELABORATI: "+articoliElaborati);
			partenza=np;

			//è un nodo orfano? lo elimino e lo salto

			if(!np.getRelationships().iterator().hasNext()){
				System.out.println("ELIMINO l'orfano "+np.getProperty("name"));
				err.scrivi("ELIMINO l'orfano "+np.getProperty("name"));
				g.elimina(np);
				continue;
			}



			if(g.getCategorieAppartenenza(partenza).size()==0) err.scrivi("Errore, la pagina "+nome+" non è categorizzata");

			//per ogni categoria di appartenenza, trovo le macrocategorie con massimo DISTx

			HashMap<String,Double> valori= new HashMap<String,Double>();

			for(Node categoria:g.getCategorieAppartenenza(np)){
				for(String prop:categoria.getPropertyKeys()){
					if(prop.startsWith("REACH")) {
						if(!valori.containsKey(prop.substring(5)))
							valori.put(prop.substring(5), (Double)categoria.getProperty(prop));
						else
							valori.put(prop.substring(5),
									(Double)categoria.getProperty(prop)+valori.get(prop.substring(5)));
					}
				}
				//System.out.println();
				//System.out.println("Analisi della categoria "+categoria.getProperty("name"));
				System.out.print("  ");

			}

			
			if(valori.isEmpty()){
				uncat.scrivi(np.getProperty("idpag").toString()+">"+nome);
				continue;
			}
			//ora ho la hashmap degli assegnamenti, la normalizzo e segno i valori
			double totale=0;
			for(Entry<String, Double> perc:valori.entrySet()){
				totale+=perc.getValue().doubleValue();
			}
			String rp="";
			for(Entry<String, Double> perc:valori.entrySet()){
				rp+=perc.getKey()+":"+new DecimalFormat("###.##").format((perc.getValue()/totale)*100)+";";
			}
			String risultato=np.getProperty("idpag").toString()+">"+nome+">"+rp;
			System.out.println(risultato);
			cat.scrivi(risultato);	
		}

		if (interrotto) System.out.println("programma interrotto manualmente");
		err.chiudi();
		uncat.chiudi();
		cat.chiudi();
		g.termina();

	}


}
